import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["option"],
    _excluded2 = ["meta", "children"];
import React from 'react';
import { Checkbox } from "@patternfly/react-core/dist/dynamic/components/Checkbox";
import MultipleChoiceListCommon from '@data-driven-forms/common/multiple-choice-list';
import FormGroup from '../form-group/form-group';

var FinalCheckbox = function FinalCheckbox(_ref) {
  var option = _ref.option,
      props = _objectWithoutProperties(_ref, _excluded);

  return /*#__PURE__*/React.createElement(Checkbox, _extends({
    isChecked: props.checked
  }, props, {
    onChange: function onChange(e, _value) {
      return props.onChange(e);
    }
  }, option));
};

var Wrapper = function Wrapper(_ref2) {
  var meta = _ref2.meta,
      children = _ref2.children,
      rest = _objectWithoutProperties(_ref2, _excluded2);

  return /*#__PURE__*/React.createElement(FormGroup, _extends({}, rest, {
    id: rest.name || rest.id,
    meta: meta
  }), children);
};

var MultipleChoiceList = function MultipleChoiceList(props) {
  return /*#__PURE__*/React.createElement(MultipleChoiceListCommon, _extends({}, props, {
    Wrapper: Wrapper,
    Checkbox: FinalCheckbox
  }));
};

export default MultipleChoiceList;