import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["item", "isActive", "isSelected"];
import React from 'react';
import CheckIcon from "@patternfly/react-icons/dist/dynamic/icons/check-icon";

var Option = function Option(_ref) {
  var item = _ref.item,
      isActive = _ref.isActive,
      isSelected = _ref.isSelected,
      props = _objectWithoutProperties(_ref, _excluded);

  return /*#__PURE__*/React.createElement("li", {
    className: "pf-v6-c-menu__list-item".concat(item.isDisabled || item.disabled ? ' pf-m-disabled' : '')
  }, /*#__PURE__*/React.createElement("button", _extends({}, props, {
    disabled: item.isDisabled || item.disabled,
    type: "button",
    className: "pf-v6-c-menu__item".concat(isSelected ? ' pf-m-selected' : '').concat(isActive ? ' pf-m-focus' : '')
  }), /*#__PURE__*/React.createElement("span", {
    className: "pf-v6-c-menu__item-main"
  }, item.label, isSelected && /*#__PURE__*/React.createElement("span", {
    className: "pf-v6-c-menu__item-icon"
  }, /*#__PURE__*/React.createElement(CheckIcon, null)), item.description && /*#__PURE__*/React.createElement("div", {
    className: "pf-v6-c-menu__item-text"
  }, item.description))));
};

export default Option;