"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Title = exports.FormError = exports.Description = exports.ButtonGroup = exports.Button = void 0;

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _formTemplate = _interopRequireDefault(require("@data-driven-forms/common/form-template"));

var _Button = require("@patternfly/react-core/dist/dynamic/components/Button");

var _Form = require("@patternfly/react-core/dist/dynamic/components/Form");

var _Content = require("@patternfly/react-core/dist/dynamic/components/Content");

var _Alert = require("@patternfly/react-core/dist/dynamic/components/Alert");

var _excluded = ["label", "bsStyle", "children", "disabled", "buttonType"],
    _excluded2 = ["children"],
    _excluded3 = ["children"],
    _excluded4 = ["children"],
    _excluded5 = ["title", "description"];

var Button = function Button(_ref) {
  var label = _ref.label,
      bsStyle = _ref.bsStyle,
      children = _ref.children,
      disabled = _ref.disabled,
      buttonType = _ref.buttonType,
      props = (0, _objectWithoutProperties2["default"])(_ref, _excluded);
  return /*#__PURE__*/_react["default"].createElement(_Button.Button, (0, _extends2["default"])({
    variant: buttonType === 'cancel' ? 'link' : bsStyle || 'secondary',
    isDisabled: disabled
  }, props), label, children);
};

exports.Button = Button;

var ButtonGroup = function ButtonGroup(_ref2) {
  var children = _ref2.children,
      props = (0, _objectWithoutProperties2["default"])(_ref2, _excluded2);
  return /*#__PURE__*/_react["default"].createElement(_Form.ActionGroup, props, children);
};

exports.ButtonGroup = ButtonGroup;

var Title = function Title(_ref3) {
  var children = _ref3.children,
      props = (0, _objectWithoutProperties2["default"])(_ref3, _excluded3);
  return /*#__PURE__*/_react["default"].createElement(_Content.Content, null, /*#__PURE__*/_react["default"].createElement(_Content.Content, (0, _extends2["default"])({
    component: _Content.ContentVariants.h1
  }, props), children));
};

exports.Title = Title;

var Description = function Description(_ref4) {
  var children = _ref4.children,
      props = (0, _objectWithoutProperties2["default"])(_ref4, _excluded4);
  return /*#__PURE__*/_react["default"].createElement(_Content.Content, null, /*#__PURE__*/_react["default"].createElement(_Content.Content, (0, _extends2["default"])({
    component: _Content.ContentVariants.p
  }, props), children));
};

exports.Description = Description;

var FormError = function FormError(_ref5) {
  var formError = _ref5.formError,
      alertProps = _ref5.alertProps;

  if ((0, _typeof2["default"])(formError) === 'object' && formError.title) {
    var title = formError.title,
        description = formError.description,
        props = (0, _objectWithoutProperties2["default"])(formError, _excluded5);
    return /*#__PURE__*/_react["default"].createElement(_Alert.Alert, (0, _extends2["default"])({
      variant: "danger",
      isInline: true,
      title: title
    }, props, alertProps), description);
  }

  if (typeof formError === 'string') {
    return /*#__PURE__*/_react["default"].createElement(_Alert.Alert, (0, _extends2["default"])({
      variant: "danger",
      isInline: true,
      title: formError
    }, alertProps));
  }

  return null;
};

exports.FormError = FormError;

var PF4FormTemplate = function PF4FormTemplate(props) {
  return /*#__PURE__*/_react["default"].createElement(_formTemplate["default"], (0, _extends2["default"])({
    BeforeError: FormError,
    FormWrapper: _Form.Form,
    Button: Button,
    ButtonGroup: ButtonGroup,
    Title: Title,
    Description: Description
  }, props));
};

var _default = PF4FormTemplate;
exports["default"] = _default;