"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof3 = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _react = _interopRequireWildcard(require("react"));

var _select = _interopRequireWildcard(require("@data-driven-forms/common/select"));

var _parseInternalValue = _interopRequireDefault(require("@data-driven-forms/common/select/parse-internal-value"));

var _downshift = _interopRequireDefault(require("downshift"));

var _caretDownIcon = _interopRequireDefault(require("@patternfly/react-icons/dist/dynamic/icons/caret-down-icon"));

var _closeIcon = _interopRequireDefault(require("@patternfly/react-icons/dist/dynamic/icons/close-icon"));

var _circleNotchIcon = _interopRequireDefault(require("@patternfly/react-icons/dist/dynamic/icons/circle-notch-icon"));

require("./select-styles.css");

require("@patternfly/react-styles/css/components/Menu/menu.css");

require("@patternfly/react-styles/css/components/Label/label.css");

require("@patternfly/react-styles/css/components/Label/label-group.css");

require("@patternfly/react-styles/css/components/Divider/divider.css");

var _menu2 = _interopRequireDefault(require("./menu"));

var _clearIndicator = _interopRequireDefault(require("./clear-indicator"));

var _valueContainer = _interopRequireDefault(require("./value-container"));

var _Icon = require("@patternfly/react-core/dist/dynamic/components/Icon");

var _excluded = ["noResultsMessage", "noOptionsMessage", "onChange", "options", "value", "simpleValue", "placeholder", "isSearchable", "isDisabled", "isClearable", "isMulti", "isFetching", "onInputChange", "loadingMessage", "menuPortalTarget", "menuIsPortal", "originalOptions"],
    _excluded2 = ["showMoreLabel", "showLessLabel", "simpleValue", "loadingMessage", "updatingMessage", "options", "menuIsPortal", "placeholder", "isSearchable", "isClearable", "noResultsMessage", "noOptionsMessage"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

var _itemToString = function itemToString(value, isMulti, showMore, handleShowMore, handleChange) {
  if (!value) {
    return '';
  }

  if (Array.isArray(value)) {
    if (!value || value.length === 0) {
      return;
    }

    if (isMulti) {
      var visibleOptions = showMore ? value : value.slice(0, 3);
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "pf-v6-c-label-group pf-v6-u-ml-sm",
        onClick: function onClick(event) {
          return event.stopPropagation();
        }
      }, /*#__PURE__*/_react["default"].createElement("ul", {
        className: "pf-v6-c-label-group__list",
        "aria-label": "Chip group category"
      }, visibleOptions.map(function (item, index) {
        var label = (0, _typeof2["default"])(item) === 'object' ? item.label : item;
        return /*#__PURE__*/_react["default"].createElement("li", {
          className: "pf-v6-c-label-group__list-item",
          onClick: function onClick(event) {
            return event.stopPropagation();
          },
          key: item.key || item.value || item
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: "pf-v6-c-label"
        }, /*#__PURE__*/_react["default"].createElement("span", {
          className: "pf-v6-c-label__text",
          id: "pf-random-id-".concat(index, "-").concat(label)
        }, label), /*#__PURE__*/_react["default"].createElement("button", {
          onClick: function onClick() {
            return handleChange(item);
          },
          className: "pf-v6-c-button pf-u-plain pf-v6-u-pt-0 pf-v6-u-pb-0",
          type: "button",
          "aria-label": "remove option"
        }, /*#__PURE__*/_react["default"].createElement(_closeIcon["default"], null))));
      }), value.length > 3 && /*#__PURE__*/_react["default"].createElement("li", {
        className: "pf-v6-c-label-group__list-item"
      }, /*#__PURE__*/_react["default"].createElement("button", {
        type: "button",
        onClick: handleShowMore,
        className: "pf-v6-c-label pf-m-overflow"
      }, /*#__PURE__*/_react["default"].createElement("span", {
        className: "pf-v6-c-label__text"
      }, showMore ? 'Show less' : "".concat(value.length - 3, " more"))))));
    }

    return value.map(function (item) {
      return (0, _typeof2["default"])(item) === 'object' ? item.label : item;
    });
  }

  if ((0, _typeof2["default"])(value) === 'object') {
    return value.label;
  }

  return value;
}; // TODO fix the value of internal select not to be an array all the time. It forces the filter value to be an array and it crashes sometimes.


var filterOptions = function filterOptions(options) {
  var filterValue = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  var filter = (Array.isArray(filterValue) && filterValue.length > 0 ? filterValue[0] : filterValue).toLowerCase();

  if (!filter) {
    return options;
  }

  return options.map(function (option) {
    var _option$label2;

    if (option.options) {
      var filteredNested = option.options.map(function (option) {
        var _option$label;

        return (_option$label = option.label) !== null && _option$label !== void 0 && _option$label.toLowerCase().includes(filter) ? option : null;
      }).filter(Boolean);

      if (filteredNested.length === 0) {
        return null;
      }

      return _objectSpread(_objectSpread({}, option), {}, {
        options: filteredNested
      });
    }

    if ((_option$label2 = option.label) !== null && _option$label2 !== void 0 && _option$label2.toLowerCase().includes(filter)) {
      return option;
    }

    return null;
  }).filter(Boolean);
};

var getValue = function getValue(isMulti, option, value) {
  if (!isMulti || !option) {
    return option;
  }

  var isSelected = value.find(function (_ref) {
    var value = _ref.value;
    return value === option.value;
  });
  return isSelected ? value.filter(function (_ref2) {
    var value = _ref2.value;
    return value !== option.value;
  }) : [].concat((0, _toConsumableArray2["default"])(value), [option]);
};

var _stateReducer = function stateReducer(state, changes, isMulti) {
  switch (changes.type) {
    case _downshift["default"].stateChangeTypes.clickButton:
      return _objectSpread(_objectSpread(_objectSpread({}, state), changes), {}, {
        highlightedIndex: undefined,
        // reset the item focus to prevent initial scroll and portal menu warping
        inputValue: undefined
      });

    case _downshift["default"].stateChangeTypes.keyDownEnter:
    case _downshift["default"].stateChangeTypes.clickItem:
      return _objectSpread(_objectSpread({}, changes), {}, {
        isOpen: isMulti ? state.isOpen : !state.isOpen,
        highlightedIndex: state.highlightedIndex,
        inputValue: isMulti ? state.inputValue : changes.inputValue // prevent filter value change after option click

      });

    case _downshift["default"].stateChangeTypes.controlledPropUpdatedSelectedItem:
      return _objectSpread(_objectSpread({}, changes), {}, {
        inputValue: state.inputValue
      });

    case _downshift["default"].stateChangeTypes.mouseUp:
      if (typeof changes.inputValue === 'string') {
        return _objectSpread({}, changes);
      }

      if (Array.isArray(changes.inputValue) && typeof changes.inputValue[0] === 'string') {
        return _objectSpread(_objectSpread({}, changes), {}, {
          inputValue: changes.inputValue[0]
        });
      }

      if (state.isOpen === true && changes.isOpen === false && changes.inputValue) {
        return _objectSpread(_objectSpread(_objectSpread({}, state), changes), {}, {
          inputValue: ''
        });
      }

      return _objectSpread(_objectSpread({}, changes), {}, {
        inputValue: state.inputValue
      });

    default:
      return changes;
  }
};

var InternalSelect = function InternalSelect(_ref3) {
  var noResultsMessage = _ref3.noResultsMessage,
      noOptionsMessage = _ref3.noOptionsMessage,
      onChange = _ref3.onChange,
      options = _ref3.options,
      value = _ref3.value,
      simpleValue = _ref3.simpleValue,
      placeholder = _ref3.placeholder,
      isSearchable = _ref3.isSearchable,
      isDisabled = _ref3.isDisabled,
      isClearable = _ref3.isClearable,
      isMulti = _ref3.isMulti,
      isFetching = _ref3.isFetching,
      onInputChange = _ref3.onInputChange,
      loadingMessage = _ref3.loadingMessage,
      menuPortalTarget = _ref3.menuPortalTarget,
      menuIsPortal = _ref3.menuIsPortal,
      originalOptions = _ref3.originalOptions,
      props = (0, _objectWithoutProperties2["default"])(_ref3, _excluded);

  var _useState = (0, _react.useState)(false),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      showMore = _useState2[0],
      setShowMore = _useState2[1];

  var inputRef = (0, _react.useRef)();
  var selectToggleRef = (0, _react.useRef)();
  var parsedValue = (0, _parseInternalValue["default"])(value);

  var handleShowMore = function handleShowMore() {
    return setShowMore(function (prev) {
      return !prev;
    });
  };

  var handleChange = function handleChange(option) {
    return onChange(getValue(isMulti, option, value));
  };

  return /*#__PURE__*/_react["default"].createElement(_downshift["default"], {
    id: props.id || props.name,
    onChange: handleChange,
    itemToString: function itemToString(value) {
      return _itemToString(value, isMulti, showMore, handleShowMore, handleChange);
    },
    selectedItem: value || '',
    stateReducer: function stateReducer(state, changes) {
      return _stateReducer(state, changes, isMulti);
    },
    onInputValueChange: function onInputValueChange(inputValue, _ref4) {
      var selectedItem = _ref4.selectedItem;

      /**
       * Prevent firing te load options callback when selecting value not filtering
       */
      if (onInputChange && typeof inputValue === 'string' && (selectedItem === null || selectedItem === void 0 ? void 0 : selectedItem.label) !== inputValue) {
        onInputChange(inputValue);
      }
    }
  }, function (_ref5) {
    var isOpen = _ref5.isOpen,
        inputValue = _ref5.inputValue,
        itemToString = _ref5.itemToString,
        selectedItem = _ref5.selectedItem,
        clearSelection = _ref5.clearSelection,
        getInputProps = _ref5.getInputProps,
        getToggleButtonProps = _ref5.getToggleButtonProps,
        getItemProps = _ref5.getItemProps,
        highlightedIndex = _ref5.highlightedIndex;
    var toggleButtonProps = getToggleButtonProps();
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: "pf-v6-c-menu"
    }, /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
      ref: selectToggleRef,
      disabled: isDisabled,
      className: "pf-v6-c-menu-toggle".concat(isDisabled ? ' pf-m-disabled' : '').concat(isSearchable ? ' pf-m-typeahead' : '', " ddorg__pf4-component-mapper__select-toggle"),
      tabIndex: 0
    }, toggleButtonProps), /*#__PURE__*/_react["default"].createElement(_valueContainer["default"], {
      isMulti: isMulti,
      isSearchable: isSearchable,
      placeholder: placeholder,
      inputRef: inputRef,
      getInputProps: getInputProps,
      value: itemToString(selectedItem, isMulti, showMore, handleShowMore, handleChange)
    }), isClearable && parsedValue && /*#__PURE__*/_react["default"].createElement(_clearIndicator["default"], {
      clearSelection: clearSelection
    }), /*#__PURE__*/_react["default"].createElement("button", {
      className: "pf-v6-c-menu-toggle__button"
    }, /*#__PURE__*/_react["default"].createElement("span", {
      className: "pf-v6-c-menu-toggle__controls"
    }, /*#__PURE__*/_react["default"].createElement("span", {
      className: "pf-v6-c-menu-toggle__toggle-icon"
    }, /*#__PURE__*/_react["default"].createElement(_Icon.Icon, null, isFetching ? /*#__PURE__*/_react["default"].createElement(_circleNotchIcon["default"], {
      className: "ddorg__pf4-component-mapper__select-loading-icon"
    }) : /*#__PURE__*/_react["default"].createElement(_caretDownIcon["default"], null)))))), isOpen && /*#__PURE__*/_react["default"].createElement(_menu2["default"], {
      noResultsMessage: noResultsMessage,
      noOptionsMessage: noOptionsMessage,
      isFetching: isFetching,
      isDisabled: isDisabled,
      isSearchable: isSearchable,
      getInputProps: getInputProps,
      filterOptions: filterOptions,
      filterValue: inputValue,
      options: options,
      getItemProps: getItemProps,
      highlightedIndex: highlightedIndex,
      selectedItem: isMulti ? value : parsedValue,
      isMulti: isMulti,
      menuPortalTarget: menuPortalTarget,
      menuIsPortal: menuIsPortal,
      selectToggleRef: selectToggleRef,
      originalOptions: originalOptions
    }));
  });
};

var Select = function Select(_ref6) {
  var _ref6$showMoreLabel = _ref6.showMoreLabel,
      showMoreLabel = _ref6$showMoreLabel === void 0 ? 'more' : _ref6$showMoreLabel,
      _ref6$showLessLabel = _ref6.showLessLabel,
      showLessLabel = _ref6$showLessLabel === void 0 ? 'Show less' : _ref6$showLessLabel,
      _ref6$simpleValue = _ref6.simpleValue,
      simpleValue = _ref6$simpleValue === void 0 ? true : _ref6$simpleValue,
      _ref6$loadingMessage = _ref6.loadingMessage,
      loadingMessage = _ref6$loadingMessage === void 0 ? 'Loading...' : _ref6$loadingMessage,
      _ref6$updatingMessage = _ref6.updatingMessage,
      updatingMessage = _ref6$updatingMessage === void 0 ? 'Loading data...' : _ref6$updatingMessage,
      _ref6$options = _ref6.options,
      options = _ref6$options === void 0 ? [] : _ref6$options,
      _ref6$menuIsPortal = _ref6.menuIsPortal,
      menuIsPortal = _ref6$menuIsPortal === void 0 ? false : _ref6$menuIsPortal,
      _ref6$placeholder = _ref6.placeholder,
      placeholder = _ref6$placeholder === void 0 ? 'Choose...' : _ref6$placeholder,
      _ref6$isSearchable = _ref6.isSearchable,
      isSearchable = _ref6$isSearchable === void 0 ? false : _ref6$isSearchable,
      _ref6$isClearable = _ref6.isClearable,
      isClearable = _ref6$isClearable === void 0 ? false : _ref6$isClearable,
      _ref6$noResultsMessag = _ref6.noResultsMessage,
      noResultsMessage = _ref6$noResultsMessag === void 0 ? 'No results found' : _ref6$noResultsMessag,
      _ref6$noOptionsMessag = _ref6.noOptionsMessage,
      noOptionsMessage = _ref6$noOptionsMessag === void 0 ? 'No options' : _ref6$noOptionsMessag,
      props = (0, _objectWithoutProperties2["default"])(_ref6, _excluded2);
  var menuPortalTarget = menuIsPortal ? document.body : undefined;
  return /*#__PURE__*/_react["default"].createElement(_select["default"], (0, _extends2["default"])({
    SelectComponent: InternalSelect,
    menuPortalTarget: menuPortalTarget,
    menuIsPortal: menuIsPortal
  }, props, {
    showMoreLabel: showMoreLabel,
    showLessLabel: showLessLabel,
    simpleValue: simpleValue,
    loadingMessage: loadingMessage,
    updatingMessage: updatingMessage,
    options: options,
    placeholder: placeholder,
    isSearchable: isSearchable,
    isClearable: isClearable,
    noResultsMessage: noResultsMessage,
    noOptionsMessage: noOptionsMessage,
    optionsTransformer: _select.flatOptions
  }));
};

var _default = Select;
exports["default"] = _default;