"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireDefault(require("react"));

var _Button = require("@patternfly/react-core/dist/dynamic/components/Button");

var _selectNext = _interopRequireDefault(require("@data-driven-forms/common/wizard/select-next"));

var _formSpy = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/form-spy"));

var NextButton = function NextButton(_ref) {
  var nextStep = _ref.nextStep,
      valid = _ref.valid,
      handleNext = _ref.handleNext,
      nextLabel = _ref.nextLabel,
      getState = _ref.getState,
      handleSubmit = _ref.handleSubmit,
      submitLabel = _ref.submitLabel,
      conditionalSubmitFlag = _ref.conditionalSubmitFlag;
  var nextResult = nextStep ? (0, _selectNext["default"])(nextStep, getState) : nextStep;
  var progressNext = nextResult !== conditionalSubmitFlag && nextStep;
  return /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    variant: "primary",
    type: "button",
    isDisabled: !valid || getState().validating,
    onClick: function onClick() {
      return progressNext ? handleNext((0, _selectNext["default"])(nextStep, getState)) : handleSubmit();
    }
  }, progressNext ? nextLabel : submitLabel);
};

var WizardStepButtons = function WizardStepButtons(_ref2) {
  var Buttons = _ref2.buttons,
      disableBack = _ref2.disableBack,
      handlePrev = _ref2.handlePrev,
      nextStep = _ref2.nextStep,
      handleNext = _ref2.handleNext,
      buttonsClassName = _ref2.buttonsClassName,
      _ref2$buttonLabels = _ref2.buttonLabels,
      cancel = _ref2$buttonLabels.cancel,
      submit = _ref2$buttonLabels.submit,
      back = _ref2$buttonLabels.back,
      next = _ref2$buttonLabels.next,
      formOptions = _ref2.formOptions,
      conditionalSubmitFlag = _ref2.conditionalSubmitFlag;
  return /*#__PURE__*/_react["default"].createElement("footer", {
    className: "pf-v6-c-wizard__footer ".concat(buttonsClassName ? buttonsClassName : '')
  }, Buttons ? /*#__PURE__*/_react["default"].createElement(Buttons, {
    disableBack: disableBack,
    handlePrev: handlePrev,
    nextStep: nextStep,
    handleNext: handleNext,
    buttonsClassName: buttonsClassName,
    buttonLabels: {
      cancel: cancel,
      submit: submit,
      back: back,
      next: next
    },
    renderNextButton: function renderNextButton(args) {
      return /*#__PURE__*/_react["default"].createElement(NextButton, (0, _extends2["default"])({}, formOptions, {
        handleNext: handleNext,
        nextStep: nextStep,
        nextLabel: next,
        submitLabel: submit
      }, args));
    },
    selectNext: _selectNext["default"]
  }) : /*#__PURE__*/_react["default"].createElement(_formSpy["default"], null, function () {
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(NextButton, (0, _extends2["default"])({}, formOptions, {
      conditionalSubmitFlag: conditionalSubmitFlag,
      handleNext: handleNext,
      nextStep: nextStep,
      nextLabel: next,
      submitLabel: submit
    })), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
      type: "button",
      variant: "secondary",
      isDisabled: disableBack,
      onClick: handlePrev
    }, back), /*#__PURE__*/_react["default"].createElement("div", {
      className: "pf-v6-c-wizard__footer-cancel"
    }, /*#__PURE__*/_react["default"].createElement(_Button.Button, {
      type: "button",
      variant: "link",
      onClick: formOptions.onCancel
    }, cancel)));
  }));
};

var _default = WizardStepButtons;
exports["default"] = _default;