"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.RenderTitle = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _Title = require("@patternfly/react-core/dist/dynamic/components/Title");

var _Wizard = require("@patternfly/react-core/dist/dynamic/components/Wizard");

var _stepButtons = _interopRequireDefault(require("./step-buttons"));

var _excluded = ["name", "title", "description", "fields", "formOptions", "showTitles", "showTitle", "customTitle", "hasNoBodyPadding", "StepTemplate"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var RenderTitle = function RenderTitle(_ref) {
  var title = _ref.title,
      customTitle = _ref.customTitle;
  return customTitle ? customTitle : /*#__PURE__*/_react["default"].createElement(_Title.Title, {
    headingLevel: "h1",
    size: "xl"
  }, title);
};

exports.RenderTitle = RenderTitle;

var DefaultStepTemplate = function DefaultStepTemplate(_ref2) {
  var formFields = _ref2.formFields,
      formRef = _ref2.formRef,
      title = _ref2.title,
      customTitle = _ref2.customTitle,
      showTitle = _ref2.showTitle,
      showTitles = _ref2.showTitles;
  return /*#__PURE__*/_react["default"].createElement("div", {
    ref: formRef,
    className: "pf-c-form"
  }, (showTitles && showTitle !== false || showTitle) && /*#__PURE__*/_react["default"].createElement(RenderTitle, {
    title: title,
    customTitle: customTitle
  }), formFields);
};

var WizardStep = function WizardStep(_ref3) {
  var name = _ref3.name,
      title = _ref3.title,
      description = _ref3.description,
      fields = _ref3.fields,
      formOptions = _ref3.formOptions,
      showTitles = _ref3.showTitles,
      showTitle = _ref3.showTitle,
      customTitle = _ref3.customTitle,
      hasNoBodyPadding = _ref3.hasNoBodyPadding,
      _ref3$StepTemplate = _ref3.StepTemplate,
      StepTemplate = _ref3$StepTemplate === void 0 ? DefaultStepTemplate : _ref3$StepTemplate,
      rest = (0, _objectWithoutProperties2["default"])(_ref3, _excluded);
  var formRef = (0, _react.useRef)();
  (0, _react.useEffect)(function () {
    // HACK: I can not pass ref to WizardBody because it is not
    // wrapped by forwardRef. However, the step body (the one that overflows)
    // is the grand parent of the form element.
    var stepBody = formRef.current && formRef.current.parentNode.parentNode;
    stepBody && stepBody.scrollTo({
      top: 0,
      left: 0,
      behavior: 'smooth'
    });
  }, [name]);
  return /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, /*#__PURE__*/_react["default"].createElement(_Wizard.WizardBody, {
    hasNoPadding: hasNoBodyPadding
  }, /*#__PURE__*/_react["default"].createElement(StepTemplate, (0, _extends2["default"])({
    formFields: fields.map(function (item) {
      return formOptions.renderForm([item], formOptions);
    }),
    name: name,
    title: title,
    description: description,
    formOptions: formOptions,
    showTitles: showTitles,
    showTitle: showTitle,
    customTitle: customTitle,
    hasNoBodyPadding: hasNoBodyPadding,
    formRef: formRef,
    fields: fields
  }, rest))), /*#__PURE__*/_react["default"].createElement(_stepButtons["default"], (0, _extends2["default"])({
    formOptions: formOptions
  }, rest)));
};

var _default = WizardStep;
exports["default"] = _default;